////>
//  Title:   Prompt Events
//  Author:  Truce
////>

registerOutputEvent("fxDTSBrick","promptClient","list OK/Cancel 0 Yes/No 1\tstring 200 170\tstring 200 100",1);
registerInputEvent("fxDTSBrick","onPromptAccept","Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame");
registerInputEvent("fxDTSBrick","onPromptDecline","Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame");

function fxDTSBrick::promptClient(%this,%type,%msg,%nums,%cl)
{
	if(!isObject(%cl.promptGroup))
		%cl.promptGroup = new SimGroup();
	
	%obj = new SimObject()
	{
		cmd  = (%type) ? 'MessageBoxYesNo' : 'MessageBoxOKCancel';
		msg  = %msg;
		obj  = %this;
		nums = %nums;
	};
	
	%cl.promptGroup.add(%obj);
	%cl.triggerPrompt();
}

function GameConnection::triggerPrompt(%this)
{
	%group = %this.promptGroup;
	
	if(%this.pendingPrompt || !isObject(%group) || !%group.getCount())
		return;
	
	%obj = %group.getObject(0);
	commandToClient(%this,%obj.cmd,"Prompt",%obj.msg,'MessageBoxAccept');
	
	%this.pendingPrompt = 1;
}

function GameConnection::processPrompt(%this,%mode)
{
	%group = %this.promptGroup;
	
	if(!%this.pendingPrompt || !isObject(%group) || !%group.getCount())
		return;
	
	%obj = %group.getObject(0);
	%group.remove(%obj);
	
	%brick = %obj.obj;
	%max   = %brick.numEvents;
	%list  = " " @ parseList(%obj.nums,0,%max - 1) @ " ";
	
	for(%i = 0; %i < %max; %i++)
	{
		%input   = %brick.eventInput[%i];
		%old[%i] = %brick.eventEnabled[%i];
		
		if((%input $= "onPromptAccept" || %input $= "onPromptDecline") && strPos(%list," " @ %i @ " ") != -1)
			%brick.eventEnabled[%i] = 1;
		else
			%brick.eventEnabled[%i] = 0;
	}
	
	if(%mode)
		%brick.onPromptAccept(%this);
	else
		%brick.onPromptDecline(%this);
	
	for(%i = 0; %i < %max; %i++)
		%brick.eventEnabled[%i] = %old[%i];
	
	%this.pendingPrompt = 0;
	%this.triggerPrompt();
}

function fxDTSBrick::onPromptAccept(%this,%cl)
{
	$InputTarget_Self   = %this;
	$InputTarget_Player = %cl.player;
	$InputTarget_Client = %cl;
	
	%clmg  = getMiniGameFromObject(%cl);
	
	if($Server::LAN)
		$InputTarget_MiniGame = %clmg;
	else
	{
		%objmg = getMiniGameFromObject(%obj);
		
		if(%objmg == %clmg)
			$InputTarget_MiniGame = %objmg;
		else
			$InputTarget_MiniGame = 0;
	}
	
	%this.processInputEvent("onPromptAccept",%cl);
}

function fxDTSBrick::onPromptDecline(%this,%cl)
{
	$InputTarget_Self   = %this;
	$InputTarget_Player = %cl.player;
	$InputTarget_Client = %cl;
	
	%clmg  = getMiniGameFromObject(%cl);
	
	if($Server::LAN)
		$InputTarget_MiniGame = %clmg;
	else
	{
		%objmg = getMiniGameFromObject(%obj);
		
		if(%objmg == %clmg)
			$InputTarget_MiniGame = %objmg;
		else
			$InputTarget_MiniGame = 0;
	}
	
	%this.processInputEvent("onPromptDecline",%cl);
}

function serverCmdMessageBoxAccept(%cl)
{
	%cl.processPrompt(1);
}

package PromptEvents
{
	function serverCmdMessageBoxCancel(%cl)
	{
		%cl.processPrompt(0);
	}
	
	function serverCmdMessageBoxNo(%cl)
	{
		%cl.processPrompt(0);
	}
};
activatePackage(PromptEvents);

function parseList(%str,%min,%max)
{
	%str = %str @ ",";
	%len = strLen(%str);
	
	for(%i = 0; %i < %len; %i++)
	{
		%chr = getSubStr(%str,%i,1);
		
		if(strPos(",-",%chr) == -1)
		{
			%num = %num @ ((strPos("0123456789",%chr) != -1) ? %chr : "");
			continue;
		}
		
		if(%num $= "")
		{
			%old = "";
			continue;
		}
		
		%a = %num;
		
		if(%old !$= "")
		{
			if(%old > %num)
			{
				%num = %old;
				%old = %a;
			}
			
			for(%j = %old; %j <= %num; %j++)
			{
				if(strPos(" " @ %list @ " "," " @ %j @ " ") == -1)
					%list = %list SPC %j;
			}
		}
		else
		{
			if(strPos(" " @ %list @ " "," " @ %num @ " ") == -1)
				%list = %list SPC %num;
		}
		
		%num = "";
		%old = ((%chr $= "-") ? %a : "");
	}
	
	%cnt = getWordCount(%list);
	
	for(%i = 0; %i < %cnt; %i++)
	{
		%num = getWord(%list,%i);
		
		if(%num >= %min && %num <= %max)
			%new = %new SPC %num;
	}
	
	return trim(%new);
}